一起学算法-122. 买卖股票的最佳时机 II
一、题目122. 买卖股票的最佳时机 II
LeetCode地址:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-ii/
难度:简单
给定一个数组 prices ,其中 prices[i] 是一支给定股票第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你可以尽可能地完成更多的交易(多次买卖一支股票)。
注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: prices = [7,1,5,3,6,4]
输出: 7
解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
示例 2:
输入: prices = [1,2,3,4,5]
输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: prices = [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
提示:
1 <= prices.length <= 3 * 104
0 <= prices[i] <= 104
二、解题思路
一开始想到的思路是这样的低买高卖就有利可图,如果价格持续走高就一直持有,直到降低前或者到最后一天。
/**
* @param {number[]} prices
* @return {number}
*/
var maxProfit = function(prices) {
var len = prices.length
var total = 0;//利润
var num = -1;//不持有股票
for(var i = 0;i < len - 1;i++){
//如果明天有利可图手里没股票就买股票,否则持有股票就卖出
if(prices[i] < prices[i+1]){
if(num == -1){
num = prices[i];
}
}else{
if(num >= 0){
total = total + prices[i] - num;
num = -1;
}
}
//如果是最后一天,手里还有股票就全卖了
if( i + 2 == len && num >= 0){
total = total + prices[i+1] - num;
num = -1;
}
}
return total;
};
来自网友类似的解法,地址
ps:这种解法符合实际股票买卖过程,但是过于繁琐,没有体现贪心思想。实际上,只要今天比昨天高就卖,赚差价。
连续涨的,也是一天一卖。卖了当天的再买今天的,明天卖有利润就可累积出最大利润。
三、实现过程
c++
class Solution {
public:
int maxProfit(vector<int>& prices) {
int day = prices.size(),sum = 0;
for(int i = 1;i < day;i++){
if(prices[i]>prices[i-1]){
sum += prices[i] - prices[i-1];
}
}
return sum;
}
};
PHP
class Solution {
/**
* @param Integer[] $prices
* @return Integer
*/
function maxProfit($prices) {
$len = count($prices);
$sum = 0;
for($i = 1;$i < $len;$i++){
if($prices[$i]>$prices[$i-1]){
$sum = $sum + $prices[$i]-$prices[$i-1];
}
}
return $sum;
}
}
JavaScript
/**
* @param {number[]} prices
* @return {number}
*/
var maxProfit = function(prices) {
var len = prices.length
var total = 0;
for(var i = 1;i < len;i++){
if(prices[i] > prices[i-1]){
total = total + prices[i] - prices[i-1];
}
}
return total;
};
四、小结
贪心算法无论实际过程如何,只要局部最优就能使得全局最优。